{
  Ten program demonstruje :
     1) "surowy" dostep do sys plikow przez DOS
     2) dostep do sys plikow przez BIOS

  A konkretnie, jest odczytywany jeden sektor ...
}

program FS02;
uses Dos;

var
  reg: registers;
  Buf: array[0..511] of char;
  blad: word;

procedure PokazBuf(ile:integer);
var i:integer;
begin
  for i:=0 to ile-1 do
    if Ord(Buf[i])>=32 then
      write(Buf[i])
    else
      write('.');
  writeln;
end;

procedure CzyscBuf;
var i:integer;
begin
  for i:=0 to sizeof(Buf)-1 do Buf[i]:=Chr(0);
end;

begin
(* "surowy" dostep do sys plikow przez DOS
   przerwanie DOS-u 0x25,
   we: AL     drive number (0=A, 1=B, etc.)
       CX     count of sectors to read/write
       DX     beginning sector (DOS logical sector number)
       DS:BX  transfer address (destination or source buffer)
   wy: AX    error code if carry flag set (CF=CY=1)

   UWAGA !!! :
       nie mozna uzywac intr() be jest to troche
       nietypowe przerwanie !!! (to jest problem Pascala)
*)
  writeln;
  writeln('"surowy" dostep do sys plikow przez DOS');
  CzyscBuf;
  asm
    mov     al,0          {select drive A}
    mov     dx,0          {select the DOS boot sector and BPB}
    mov     cx,1          {read one sector}
    lea     bx,Buf        {into buffer at DS:BX}
    int     25H
    pop     dx            {discard the extra word on the stack !!!}
    mov     blad,0
    jnc     @noErr
    mov     blad,1
    @noErr:
  end;
  if blad=1 then begin
    writeln('Blad !!!'); exit;
  end;
  PokazBuf(32);



(* dostep do sys plikow przez BIOS
   przerwanie BIOS-u 0x13, funkcja 02
   DL = drive number (0=drive A...; 80H=hard disk 0; 81H=hard disk 1)
   DH = read/write head number
   CH = track (cylinder) number (0-n) 
   CL = sector number (1-n)  See note below.
   AL = sector count (no more than 1 cylinder's worth of sectors)
   ES:BX => caller's buffer address
*)
  reg.DL:=0; { czyli "A:" }
  reg.DH:=0; { glowica nr 0 }
  reg.CH:=0; { cylinder nr 0 }
  reg.CL:=1; { "fizyczny" nr sektora (od 1 !!!) }
  reg.AL:=1; { jeden sektor }
  reg.AH:=2; { nr funkcji }
  reg.ES:=Seg(Buf);
  reg.BX:=Ofs(Buf);


  writeln('dostep do sys plikow przez BIOS');
  CzyscBuf;
  intr($13, reg);
  if (reg.flags and 1) <> 0 then begin
    writeln('Blad !!!: flags&1=', reg.flags and 1, ' ah=', reg.AH);
    exit;
  end;

  PokazBuf(32);
end.


